'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _style = require('./style.css');

var _style2 = _interopRequireDefault(_style);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function emptyFn() {}

var Flipbox = function (_Component) {
  (0, _inherits3.default)(Flipbox, _Component);

  function Flipbox() {
    (0, _classCallCheck3.default)(this, Flipbox);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Flipbox).apply(this, arguments));
  }

  (0, _createClass3.default)(Flipbox, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.el = _reactDom2.default.findDOMNode(this);
      this.onShown(this.props.visible);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      var _this2 = this;

      var visible = props.visible;
      if (visible !== this.props.visible) {
        this.onShow(visible);
      }
      this.timer = setTimeout(function () {
        if (_this2.props.visible === visible) {
          _this2.onShown(visible);
        }
      }, 350);
    }
  }, {
    key: 'onShow',
    value: function onShow(visible) {
      this.refs[0].style.display = 'block';
      this.refs[1].style.display = 'block';
      this.props.onShow(visible);
    }
  }, {
    key: 'onShown',
    value: function onShown(visible) {
      var pStyle = this.props.style;
      var current = visible === 'front' ? 0 : 1;
      var back = 1 ^ current;
      this.refs[back].style.display = 'none';
      var curr = this.refs[current];
      var height = curr.clientHeight;
      var width = curr.clientWidth;
      var style = this.el.style;
      if (!pStyle || !pStyle.width) {
        style.width = width + 'px';
      }
      if (!pStyle || !pStyle.height) {
        style.height = height + 'px';
      }
      this.props.onShown(visible);
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var clz = (0, _classnames2.default)(_style2.default.flipbox, props.className, (0, _defineProperty3.default)({}, _style2.default.flipped, props.visible === 'back'));
      return _react2.default.createElement(
        'div',
        { className: clz, style: props.style },
        _react2.default.createElement(
          'div',
          { className: _style2.default.wrapper },
          _react.Children.map(props.children, function (el, idx) {
            return _react2.default.cloneElement(el, { ref: idx });
          })
        )
      );
    }
  }]);
  return Flipbox;
}(_react.Component);

Flipbox.defaultProps = {
  visible: 'front',
  onShow: emptyFn,
  onShown: emptyFn
};
Flipbox.propTypes = {
  visible: _propTypes2.default.oneOf(['front', 'back']),
  onShow: _propTypes2.default.func,
  onShown: _propTypes2.default.func,
  children: function children(props, propName) {
    var children = props[propName];
    if (_react.Children.count(children) !== 2) throw new Error('Expect two children to work');
    _react.Children.map(children, function (child) {
      if (!child.type == 'div') throw new Error('Expect div children');
    });
  }
};
exports.default = Flipbox;